package com.tecnalia.across.ujse.configuration;

import org.keycloak.adapters.springsecurity.KeycloakConfiguration;
import org.keycloak.adapters.springsecurity.authentication.KeycloakAuthenticationProvider;
import org.keycloak.adapters.springsecurity.config.KeycloakWebSecurityConfigurerAdapter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.http.HttpMethod;
import org.springframework.security.config.annotation.authentication.builders.AuthenticationManagerBuilder;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.http.SessionCreationPolicy;
import org.springframework.security.core.authority.mapping.SimpleAuthorityMapper;
import org.springframework.security.core.session.SessionRegistryImpl;
import org.springframework.security.web.authentication.session.RegisterSessionAuthenticationStrategy;
import org.springframework.security.web.authentication.session.SessionAuthenticationStrategy;

@KeycloakConfiguration
class SecurityConfig extends KeycloakWebSecurityConfigurerAdapter {

    @Autowired
    public void configureGlobal( AuthenticationManagerBuilder auth ) throws Exception {
 
        KeycloakAuthenticationProvider keycloakAuthenticationProvider = keycloakAuthenticationProvider();
        keycloakAuthenticationProvider.setGrantedAuthoritiesMapper( new SimpleAuthorityMapper() );
        auth.authenticationProvider(keycloakAuthenticationProvider);
    }

    @Bean
    @Override
    protected SessionAuthenticationStrategy sessionAuthenticationStrategy() {
        return new RegisterSessionAuthenticationStrategy( new SessionRegistryImpl() );
    }

    @Override
    protected void configure(HttpSecurity http) throws Exception {
        super.configure(http);

     /*   http.cors().and().csrf().disable().formLogin().disable().headers().httpStrictTransportSecurity().disable().and()
                        .sessionManagement().sessionCreationPolicy(SessionCreationPolicy.ALWAYS).and()
            .authorizeRequests()
            .antMatchers(HttpMethod.GET, "/workflowExecutionManagement/**").hasRole("citizen")
            .antMatchers(HttpMethod.POST, "/workflowExecutionManagement/**").hasRole("citizen")
            .antMatchers(HttpMethod.PUT, "/workflowExecutionManagement/**").hasRole("citizen")
            .antMatchers(HttpMethod.DELETE, "/workflowExecutionManagement/**").hasRole("citizen")
            .antMatchers("/workflowManagement/**").permitAll()
            .antMatchers("/**").permitAll();*/
     
       http.cors().and()
            .csrf().disable()
            .authorizeRequests()
            .antMatchers(HttpMethod.PUT, "/workflowExecutionManagement/setServiceStatusAsynchronous").permitAll()
            .antMatchers(HttpMethod.GET, "/workflowExecutionManagement/**").hasRole("citizen")
            .antMatchers(HttpMethod.POST, "/workflowExecutionManagement/**").hasRole("citizen")
            .antMatchers(HttpMethod.PUT, "/workflowExecutionManagement/**").hasRole("citizen")
            .antMatchers(HttpMethod.DELETE, "/workflowExecutionManagement/**").hasRole("citizen")
            .antMatchers(HttpMethod.GET, "/logManagement").hasRole("citizen")
            .antMatchers(HttpMethod.POST, "/logManagement").hasRole("citizen")
            .antMatchers(HttpMethod.GET, "/logManagement/Paged").hasRole("citizen")
            .antMatchers(HttpMethod.GET, "/logManagement/StatisticsInfo").permitAll()
            .antMatchers("/workflowManagement/**").permitAll()
            .antMatchers("/**").permitAll();

       /*http.cors().and().csrf().disable().formLogin().disable().headers().httpStrictTransportSecurity().disable().and()
                        .sessionManagement().sessionCreationPolicy(SessionCreationPolicy.ALWAYS).and()
                        .authorizeRequests()
                        .antMatchers("/**").permitAll(); */       

        /*http
          .csrf().disable()
          .authorizeRequests()
          .antMatchers(HttpMethod.GET, "/api/rest/v1/**").hasRole("citizen")
          .antMatchers(HttpMethod.POST, "/api/rest/v1/**").hasRole("citizen")
          .antMatchers(HttpMethod.PUT, "/api/rest/v1/**").hasRole("citizen")
          .antMatchers(HttpMethod.DELETE, "/api/rest/v1/**").hasRole("citizen")
          .and()
	      .cors() // Habilita el CORS
	      .and()
		  .sessionManagement().sessionCreationPolicy(SessionCreationPolicy.STATELESS); */// Deshabilita el uso de las sesiones*/
    }
}
