package com.tecnalia.across.ujse.external;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.tecnalia.across.ujse.external.model.Search;
import com.tecnalia.across.ujse.external.model.SearchApplicationPeriod;
import com.tecnalia.across.ujse.model.OutputDataElem;
import com.tecnalia.across.ujse.model.UserInfo;
import com.tecnalia.across.ujse.utils.HttpUtils;
import com.tecnalia.across.ujse.utils.IdentityUtils;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.web.multipart.MultipartFile;

/**
 *
 * @author tecnalia
 */
public class MockupServices {
    
    public List<OutputDataElem> invokeService(String serviceName, List<MultipartFile> inputData, String serviceUrlRoot) 
            throws IOException, UnsupportedEncodingException{
        ArrayList<OutputDataElem> serviceOutput = new ArrayList<OutputDataElem>();
        for (MultipartFile mf : inputData) {
            System.out.println(mf.getName());
            System.out.println(mf.getOriginalFilename());
            try {
                System.out.println(mf.getBytes().toString());
            } catch(IOException e) {
                e.printStackTrace();
            }
            System.out.println(mf.getContentType());
            System.out.println(mf.getSize());
        }
        
        if(serviceName.contains("Search")) {
            /*
            OutputDataElem output1 = new OutputDataElem();
            output1.setOutputId("searchOutput1");
            output1.setTitle("Search output");
            output1.setDescription("Search output element");
            output1.setType(OutputDataElem.TypeEnum.valueOf("STRING"));            
            output1.setLanguage("English");
            output1.setContent("Biotechnology".getBytes());
            serviceOutput.add(output1);
            byte[] pp = "Biotechnology".getBytes();
            String kk = new String(pp, StandardCharsets.UTF_8);
            System.out.println("convertyir bytes a string: " + pp);
            System.out.println("convertyir bytes a string: " + kk);

            OutputDataElem output2 = new OutputDataElem();
            output2.setOutputId("searchOutput2");
            output2.setTitle("Search output");
            output2.setDescription("Search output element");
            output2.setType(OutputDataElem.TypeEnum.valueOf("STRING"));            
            output2.setLanguage("English");
            output2.setContent("Biology".getBytes());
            serviceOutput.add(output2);

            OutputDataElem output3 = new OutputDataElem();
            output3.setOutputId("searchOutput3");
            output3.setTitle("Search output");
            output3.setDescription("Search output element");
            output3.setType(OutputDataElem.TypeEnum.valueOf("STRING"));            
            output3.setLanguage("English");
            output3.setContent("Chemistry".getBytes());
            serviceOutput.add(output3);

            OutputDataElem output4 = new OutputDataElem();
            output4.setOutputId("searchOutput4");
            output4.setTitle("Search output");
            output4.setDescription("Search output element");
            output4.setType(OutputDataElem.TypeEnum.valueOf("STRING"));            
            output4.setLanguage("English");
            output4.setContent("Geology".getBytes());
            serviceOutput.add(output4);*/
            String searchOutputStr = invokeServiceSearch(serviceUrlRoot, inputData);
            final ObjectMapper objectMapper = new ObjectMapper();
            try {
                Search[] searchOutputOjbArray = objectMapper.readValue(searchOutputStr, Search[].class);
                for(Search searchElem: searchOutputOjbArray) {
                    OutputDataElem output1 = new OutputDataElem();
                    output1.setOutputId(""+searchElem.getId());
                    output1.setTitle("Search output");
                    output1.setDescription("Search output element");
                    output1.setType("string");            
                    output1.setLanguage("English");
                    String content = searchElem.getInstitution() + " - " +
                            searchElem.getName() + " - " +
                            searchElem.getDegree() + " - " + 
                            searchElem.getSemester() + " - " +
                            "From: " + searchElem.getApplicationPeriod().getFrom() + " To: " +
                            searchElem.getApplicationPeriod().getTo();
                    output1.setContent(content.getBytes());
                    serviceOutput.add(output1);
                }
            } catch (JsonProcessingException e) {
                e.printStackTrace();
                System.out.println(e.toString());
            }
        } else if (serviceName.contains("Apply")) {
            /*OutputDataElem output1 = new OutputDataElem();
            output1.setOutputId("courseAppliedTo1");
            output1.setTitle("Apply output");
            output1.setDescription("Apply output element");
            output1.setType(OutputDataElem.TypeEnum.valueOf("STRING"));            
            output1.setLanguage("English");
            output1.setContent("Biotechnology".getBytes());
            serviceOutput.add(output1);  */
            String applyOutputStr = invokeServiceApply(serviceUrlRoot, inputData);
            OutputDataElem output1 = new OutputDataElem();
            output1.setOutputId("courseAppliedTo");
            output1.setTitle("Apply output");
            output1.setDescription("Apply output element");
            output1.setType("string");            
            output1.setLanguage("English");
            output1.setContent(applyOutputStr.getBytes());
            serviceOutput.add(output1);  
        } else if (serviceName.contains("Create")) {
            /*OutputDataElem output1 = new OutputDataElem();
            output1.setOutputId("courseAppliedTo1");
            output1.setTitle("Apply output");
            output1.setDescription("Apply output element");
            output1.setType(OutputDataElem.TypeEnum.valueOf("STRING"));            
            output1.setLanguage("English");
            output1.setContent("Biotechnology".getBytes());
            serviceOutput.add(output1);  */
            String applyOutputStr = invokeServiceCreate(serviceUrlRoot, inputData);
            OutputDataElem output1 = new OutputDataElem();
            output1.setOutputId("courseAppliedTo");
            output1.setTitle("Apply output");
            output1.setDescription("Apply output element");
            output1.setType("string");            
            output1.setLanguage("English");
            output1.setContent(applyOutputStr.getBytes());
            serviceOutput.add(output1);  
        } 
        
        return serviceOutput;
    }

    String invokeServiceSearch(String serviceUrlRoot, List<MultipartFile> inputData) throws IOException, UnsupportedEncodingException{
        //Get input data
        String institution = "";
        String subject = "";
        String federalStateId = "";
        for (MultipartFile mf : inputData) {
            if(mf.getOriginalFilename().compareTo("institution") == 0){
                institution = new String(mf.getBytes(), StandardCharsets.UTF_8);
                institution = institution.trim();
            } else if(mf.getOriginalFilename().compareTo("subject") == 0){
                subject = new String(mf.getBytes(), StandardCharsets.UTF_8);
                subject = subject.trim();
            } else if(mf.getOriginalFilename().compareTo("federalStateId") == 0){
                federalStateId = new String(mf.getBytes(), StandardCharsets.UTF_8);
                federalStateId = federalStateId.trim();
            }
        }
        
        HttpUtils httpUtil=new HttpUtils();
        //Generate service invocation URL
        String serviceUrl = serviceUrlRoot + "/applications/search" + "?";
        serviceUrl = serviceUrl + "institution=" + URLEncoder.encode(institution, StandardCharsets.UTF_8.toString());
        serviceUrl = serviceUrl + "&subject=" + URLEncoder.encode(subject, StandardCharsets.UTF_8.toString());
        if(federalStateId.length() > 0)
            serviceUrl = serviceUrl + "&federalStateId=" + URLEncoder.encode(federalStateId, StandardCharsets.UTF_8.toString());
        //Invoke the service
        String searchOutputStr = httpUtil.sendGETRequest(serviceUrl, null);
        //String searchOutputStr = simulateSearchServiceOutput();
        return searchOutputStr;
    }
    
    
    String simulateSearchServiceOutput () {
        String searchResultStr;
 
        JSONArray searchResultJArray = new JSONArray();
        JSONObject searchResultElem1 = new JSONObject();
        searchResultElem1.put("id", 1);
        searchResultElem1.put("federalStateId", 1);
        searchResultElem1.put("semester", "First semester");
        searchResultElem1.put("institution", "Hamburg");
        searchResultElem1.put("name", "Biotechnology");
        searchResultElem1.put("degree", "Bachelor");
        JSONObject appPeriod = new JSONObject();
        appPeriod.put("from", "2022-09-01T09:00:00Z");
        appPeriod.put("to", "2023-06-20T21:00:00Z");
        searchResultElem1.put("applicationPeriod", appPeriod);
        searchResultJArray.put(searchResultElem1);
        
        Search searchObj = new Search();
        searchObj.setId(1);
        searchObj.setSemester("Second Semester");
        searchObj.setInstitution("Munich");
        searchObj.setName("Biology");
        searchObj.setDegree("Master");
        searchObj.setFederalStateId(2);
        SearchApplicationPeriod applicationPeriod = new SearchApplicationPeriod();
        applicationPeriod.setFrom("2022-09-01T09:00:00Z");
        applicationPeriod.setTo("2023-06-20T21:00:00Z");
        searchObj.setApplicationPeriod(applicationPeriod);
        try {
            JSONObject searchResultElem = new JSONObject(new ObjectMapper().writeValueAsString(searchObj));
            searchResultJArray.put(searchResultElem); 
        } catch (JsonProcessingException e) {
            e.printStackTrace();
            System.out.println(e.toString());
        }
           
        
        searchResultStr = searchResultJArray.toString(); 

        return searchResultStr;
    }
    

    String invokeServiceApply(String serviceUrlRoot, List<MultipartFile> inputData) throws IOException{
        String groupId = "1";
        String firstname = "John";
        String lastname = "Doe";
        String street = "Alameda Rekalde";
        String houseNumber = "14";
        String zipCode = "48000";
        String city = "Bilbao";
        String state = "Bizkaia";
        String country = "Spain";
        /*String firstname = "";
        String lastname = "";
        String street = "";
        String houseNumber = "";
        String zipCode = "";
        String city = "";
        String state = "";
        String country = "";*/
        //Get groupId,name and address from Keycloak
        try {
            UserInfo userInfo = IdentityUtils.getUserInfoFromAccessToken();
            groupId = userInfo.getUserId();
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("Something went wrong with access-token:"+e.getMessage());
        }
        /*firstname = userInfo.getFirstname();
        lastname = userInfo.getLastname();
        street = userInfo.getStreet();
        houseNumber = "";
        zipCode = userInfo.getZipCode();
        city = userInfo.getCity();
        state = userInfo.getState();
        country = userInfo.getCountry();*/
        
        //Get input data
        String semester = "";
        String institution = "";
        String course = "";
        for (MultipartFile mf : inputData) {
            if(mf.getOriginalFilename().compareTo("semester") == 0){
                semester = new String(mf.getBytes(), StandardCharsets.UTF_8);
                semester = semester.trim();
            } else if(mf.getOriginalFilename().compareTo("institution") == 0){
                institution = new String(mf.getBytes(), StandardCharsets.UTF_8);
                institution = institution.trim();
            } else if(mf.getOriginalFilename().compareTo("course") == 0){
                course = new String(mf.getBytes(), StandardCharsets.UTF_8);
                course = course.trim();
            } else if(mf.getOriginalFilename().compareTo("firstname") == 0){
                firstname = new String(mf.getBytes(), StandardCharsets.UTF_8);
                firstname = firstname.trim();
            } else if(mf.getOriginalFilename().compareTo("lastname") == 0){
                lastname = new String(mf.getBytes(), StandardCharsets.UTF_8);
                lastname = lastname.trim();
            } else if(mf.getOriginalFilename().compareTo("street") == 0){
                street = new String(mf.getBytes(), StandardCharsets.UTF_8);
                street = street.trim();
            } else if(mf.getOriginalFilename().compareTo("houseNumber") == 0){
                houseNumber = new String(mf.getBytes(), StandardCharsets.UTF_8);
                houseNumber = houseNumber.trim();
            } else if(mf.getOriginalFilename().compareTo("zipCode") == 0){
                zipCode = new String(mf.getBytes(), StandardCharsets.UTF_8);
                zipCode = zipCode.trim();
            } else if(mf.getOriginalFilename().compareTo("city") == 0){
                city = new String(mf.getBytes(), StandardCharsets.UTF_8);
                city = city.trim();
            } else if(mf.getOriginalFilename().compareTo("state") == 0){
                state = new String(mf.getBytes(), StandardCharsets.UTF_8);
                state = state.trim();
            } else if(mf.getOriginalFilename().compareTo("country") == 0){
                country = new String(mf.getBytes(), StandardCharsets.UTF_8);
                country = country.trim();
            }
        }
        
        JSONObject courseJson = new JSONObject();
        courseJson.put("firstname", firstname);
        courseJson.put("lastname", lastname);
        JSONObject addressJsonObj = new JSONObject();
        addressJsonObj.put("street", street);
        addressJsonObj.put("houseNumber", "");
        addressJsonObj.put("zipCode", zipCode);
        addressJsonObj.put("city", city);
        addressJsonObj.put("state", state);
        addressJsonObj.put("country", country);
        courseJson.put("address", addressJsonObj);
        courseJson.put("semester", semester);
        courseJson.put("institution", institution);
        courseJson.put("course", course);


        HttpUtils httpUtil=new HttpUtils();
        String serviceUrl = serviceUrlRoot + "/applications/";
        serviceUrl = serviceUrl + groupId;
        //Invoke the service
        String applyOutputStr=httpUtil.sendPOSTRequest(serviceUrl, null, courseJson.toString());
        //String applyOutputStr = simulateApplyServiceOutput();
        return applyOutputStr;
    }
    
     String invokeServiceCreate(String serviceUrlRoot, List<MultipartFile> inputData) throws IOException{
         
        String groupId="1";
        String username = "John";
        String password = "Doe";
        String email = "Alameda Rekalde";
        String mobile = "14";
        String academicStatus = "48000";
        String firstname = "Bilbao";
        String lastname = "Bizkaia";
        String institution = "Spain";
        String department = "";
        String registrationNumber = "";
        String street = "";
        String zipCode = "";
        String city = "";
        String state = "";
        String country = "";
        String studentNo = "";
        String SSN = "";
        String firstRegistrationMonth = "";
        String firstRegistrationYear = "";
        String distributionPoint = "";
       
        
        //Get groupId,name and address from Keycloak
        try {
            UserInfo userInfo = IdentityUtils.getUserInfoFromAccessToken();
            groupId = userInfo.getUserId();
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("Something went wrong with access-token:"+e.getMessage());
        }
        /*firstname = userInfo.getFirstname();
        lastname = userInfo.getLastname();
        street = userInfo.getStreet();
        houseNumber = "";
        zipCode = userInfo.getZipCode();
        city = userInfo.getCity();
        state = userInfo.getState();
        country = userInfo.getCountry();*/
        
        //Get input data
    
        for (MultipartFile mf : inputData) {
            if(mf.getOriginalFilename().compareTo("username") == 0){
                username = new String(mf.getBytes(), StandardCharsets.UTF_8);
                username = username.trim();
            } else if(mf.getOriginalFilename().compareTo("password") == 0){
                password = new String(mf.getBytes(), StandardCharsets.UTF_8);
                password = password.trim();
            } else if(mf.getOriginalFilename().compareTo("email") == 0){
                email = new String(mf.getBytes(), StandardCharsets.UTF_8);
                email = email.trim();
            } else if(mf.getOriginalFilename().compareTo("mobile") == 0){
                mobile = new String(mf.getBytes(), StandardCharsets.UTF_8);
                mobile = mobile.trim();
            } else if(mf.getOriginalFilename().compareTo("academicStatus") == 0){
                academicStatus = new String(mf.getBytes(), StandardCharsets.UTF_8);
                academicStatus = academicStatus.trim();
            } else if(mf.getOriginalFilename().compareTo("firstname") == 0){
                firstname = new String(mf.getBytes(), StandardCharsets.UTF_8);
                firstname = firstname.trim();
            } else if(mf.getOriginalFilename().compareTo("lastname") == 0){
                lastname = new String(mf.getBytes(), StandardCharsets.UTF_8);
                lastname = lastname.trim();
            } else if(mf.getOriginalFilename().compareTo("institution") == 0){
                institution = new String(mf.getBytes(), StandardCharsets.UTF_8);
                institution = institution.trim();
            } else if(mf.getOriginalFilename().compareTo("department") == 0){
                department = new String(mf.getBytes(), StandardCharsets.UTF_8);
                department = department.trim();
            } else if(mf.getOriginalFilename().compareTo("registrationNumber") == 0){
                registrationNumber = new String(mf.getBytes(), StandardCharsets.UTF_8);
                registrationNumber = registrationNumber.trim();
            } else if(mf.getOriginalFilename().compareTo("street") == 0){
                street = new String(mf.getBytes(), StandardCharsets.UTF_8);
                street = street.trim();
            }
            else if(mf.getOriginalFilename().compareTo("zipCode") == 0){
                zipCode = new String(mf.getBytes(), StandardCharsets.UTF_8);
                zipCode = zipCode.trim();
            }
            else if(mf.getOriginalFilename().compareTo("city") == 0){
                city = new String(mf.getBytes(), StandardCharsets.UTF_8);
                city = city.trim();
            }
            else if(mf.getOriginalFilename().compareTo("state") == 0){
                state = new String(mf.getBytes(), StandardCharsets.UTF_8);
                state = state.trim();
            }
            else if(mf.getOriginalFilename().compareTo("country") == 0){
                country = new String(mf.getBytes(), StandardCharsets.UTF_8);
                country = country.trim();
            }
            else if(mf.getOriginalFilename().compareTo("studentNo") == 0){
                studentNo = new String(mf.getBytes(), StandardCharsets.UTF_8);
                studentNo = studentNo.trim();
            }
            else if(mf.getOriginalFilename().compareTo("SSN") == 0){
                SSN = new String(mf.getBytes(), StandardCharsets.UTF_8);
                SSN = SSN.trim();
            }
            else if(mf.getOriginalFilename().compareTo("firstRegistrationMonth") == 0){
                firstRegistrationMonth = new String(mf.getBytes(), StandardCharsets.UTF_8);
                firstRegistrationMonth = firstRegistrationMonth.trim();
            }
            else if(mf.getOriginalFilename().compareTo("firstRegistrationYear") == 0){
                firstRegistrationYear = new String(mf.getBytes(), StandardCharsets.UTF_8);
                firstRegistrationYear = firstRegistrationYear.trim();
            }
            else if(mf.getOriginalFilename().compareTo("distributionPoint") == 0){
                distributionPoint = new String(mf.getBytes(), StandardCharsets.UTF_8);
                distributionPoint = distributionPoint.trim();
            }
        }
        

        
        
        JSONObject accountInfo = new JSONObject();
        accountInfo.put("username", username);
        accountInfo.put("password", password);
        accountInfo.put("email", email);
        accountInfo.put("mobile", mobile);
        
        JSONObject studentInfo = new JSONObject();
        studentInfo.put("academicStatus", academicStatus);
        studentInfo.put("firstname", firstname);
        studentInfo.put("lastname", lastname);
        studentInfo.put("institution", institution);
        studentInfo.put("department", department);
        studentInfo.put("registrationNumber", registrationNumber);
        

        JSONObject address = new JSONObject();
        address.put("street", street);
        address.put("zipCode", zipCode);
        address.put("city", city);
        address.put("state", state);
        address.put("country", country);

        
        JSONObject studentInfoExt = new JSONObject();
        studentInfoExt.put("academicStatus", academicStatus);
        studentInfoExt.put("studentNo", studentNo);
        studentInfoExt.put("SSN", SSN);
        studentInfoExt.put("firstRegistrationMonth", firstRegistrationMonth);
        studentInfoExt.put("firstRegistrationYear", firstRegistrationYear);
       
  
        JSONObject input = new JSONObject();
        
        
        input.put("accountInfo", accountInfo);
        input.put("studentInfo", studentInfo);
        input.put("address", address);
        input.put("studentInfoExt", studentInfoExt);
        input.put("distributionPoint", distributionPoint);


        HttpUtils httpUtil=new HttpUtils();
        String serviceUrl = serviceUrlRoot + "/applications/create";
       // serviceUrl = serviceUrl + groupId;
        //Invoke the service
        String applyOutputStr=httpUtil.sendPOSTRequest(serviceUrl, null, input.toString());
        //String applyOutputStr = simulateApplyServiceOutput();
        return applyOutputStr;
    }


    String simulateApplyServiceOutput () {
        String applyResultStr;
        JSONObject applyResultObj = new JSONObject();
        applyResultObj.put("id", 16);
        applyResultStr = applyResultObj.toString();
        return applyResultStr;
    }    
}
