/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.tecnalia.across.ujse.external;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.tecnalia.across.ujse.model.ServiceInfo;
import com.tecnalia.across.ujse.model.UserInfo;
import com.tecnalia.across.ujse.utils.HttpUtils;
import com.tecnalia.across.ujse.utils.IdentityUtils;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;
import org.json.JSONArray;
import org.json.JSONObject;

/**
 *
 * @author tecnalia
 */
public class TransparencyDashboard {
    
    public List<ServiceInfo> getNotConsentGivenServicesList (String url, List<ServiceInfo> services,
            String oauthUrl, String oauthTokenUrlPart) throws JsonProcessingException, IOException{


        List<ServiceInfo> servicesInfo = new ArrayList<>();
        //String token = getToken (oauthUrl, oauthTokenUrlPart);
        UserInfo userInfo = IdentityUtils.getUserInfoFromAccessToken();
        String token = userInfo.getAccessToken();
        
        ObjectMapper objectMapper = new ObjectMapper();
        objectMapper.enable(SerializationFeature.INDENT_OUTPUT);
        String servicesAsString = objectMapper.writeValueAsString(services);


        HttpUtils httpUtil=new HttpUtils();
        String output=httpUtil.sendPOSTRequest(url,token, servicesAsString);

        //System.out.println(output);
        JSONArray outputArray=new JSONArray(output);
        for (Object obj:  outputArray){
            JSONObject objJSON=(JSONObject)obj;
            ServiceInfo service=new ServiceInfo();
            service.setServiceId(objJSON.getString("serviceId"));
            service.setServiceName(objJSON.getString("serviceName"));
            servicesInfo.add(service);


        }

        return servicesInfo;
    }
    
    public boolean selectServicesByUser( String url, List<ServiceInfo> listWithoutConsent,
            String oauthUrl, String oauthTokenUrlPart) throws JsonProcessingException, IOException {

        boolean bResult=true;

        List<String> servicesId=new ArrayList<>();
        //String token = getToken (oauthUrl, oauthTokenUrlPart);
        UserInfo userInfo = IdentityUtils.getUserInfoFromAccessToken();
        String token = userInfo.getAccessToken();

        try{
            for (ServiceInfo serviceWithoutConsent : listWithoutConsent){
                ServiceInfo service=(ServiceInfo) serviceWithoutConsent;
                String serviceId=service.getServiceId();
                servicesId.add(serviceId);
            }
            ObjectMapper objectMapper = new ObjectMapper();
            objectMapper.enable(SerializationFeature.INDENT_OUTPUT);
            String servicesIdAsString = objectMapper.writeValueAsString(servicesId);
            HttpUtils httpUtil=new HttpUtils();
            String output="";
            output=httpUtil.sendPOSTRequest(url,token, servicesIdAsString);
            if (output.equals("")) return false;

            //System.out.println(output);
        }
        catch(Exception e)
        {
            bResult=false;
        }    
  
        return bResult;      

    }       

    
    public boolean checkServiceConsentStatusByUser(String url, 
            String oauthUrl, String oauthTokenUrlPart) throws IOException{

        boolean bResult=true;
        //String token = getToken (oauthUrl, oauthTokenUrlPart);
        UserInfo userInfo = IdentityUtils.getUserInfoFromAccessToken();
        String token = userInfo.getAccessToken();
        
        try{
            HttpUtils httpUtil=new HttpUtils();
            String output="";
            output=httpUtil.sendGETRequest(url, token);
            bResult=Boolean.parseBoolean(output);  

        }
        catch(Exception e)
        {
            bResult=false;
        }    
        return bResult;      


    }       

    
    public JSONArray getConsentInfoForService (String url, String serviceId,
            String oauthUrl, String oauthTokenUrlPart) throws JsonProcessingException, IOException{

        JSONArray persDataArray = new JSONArray();
        //String token = getToken (oauthUrl, oauthTokenUrlPart);
        UserInfo userInfo = IdentityUtils.getUserInfoFromAccessToken();
        String token = userInfo.getAccessToken();

        ObjectMapper objectMapper = new ObjectMapper();
        objectMapper.enable(SerializationFeature.INDENT_OUTPUT);
        JSONArray servicesArrJson = new JSONArray();
        servicesArrJson.put(serviceId);
        HttpUtils httpUtil = new HttpUtils();
        String output = httpUtil.sendPOSTRequest(url,token, servicesArrJson.toString());

        //System.out.println(output);
        JSONArray servicesArray = new JSONArray(output);
        for (Object obj:  servicesArray){
            JSONObject serviceJsonObject=(JSONObject)obj;
            if (serviceJsonObject.has("serviceId")) {
                String responseServiceId = serviceJsonObject.getString("serviceId");
                if (responseServiceId.equals(serviceId)) {
                    if (serviceJsonObject.has("personalData")) {
                        persDataArray = serviceJsonObject.getJSONArray("personalData");
                    }
                }
            }
        }
        
        return persDataArray;          
    }

    
    public boolean logPersonalDataUsage(String consentInfoServiceUrl, 
            String oauthUrl, String oauthTokenUrlPart) throws  IOException {
        boolean bResult=true;
        //String token = getToken (oauthUrl, oauthTokenUrlPart);
        UserInfo userInfo = IdentityUtils.getUserInfoFromAccessToken();
        String token = userInfo.getAccessToken();
        try{
            HttpUtils httpUtil=new HttpUtils();
            String output="";
            output=httpUtil.sendPOSTRequest(consentInfoServiceUrl, token, "");
        }
        catch(Exception e)
        {
            bResult=false;
        }    
        return bResult;      
    }

    
    public String getTokenOld (String oauthUrl, String oauthTokenUrlPart) throws IOException{
        //TODO: Remove this function
        
    	URL url = new URL (oauthUrl + oauthTokenUrlPart);
		
        HttpURLConnection con = (HttpURLConnection)url.openConnection();
        con.setRequestMethod("POST");

        con.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
        con.setRequestProperty("Accept", "application/json");

        con.setDoOutput(true);

        /*JSONObject authBodyJson = new JSONObject();
        authBodyJson.put("client_id", "transparency-dashboard-frontend");
        authBodyJson.put("grant_type", "password");
        authBodyJson.put("username", "test-user");
        authBodyJson.put("password", "test-user");
        String authBodyStr = authBodyJson.toString();*/
        
        //Get auth data from access-token
        StringBuilder authBody = new StringBuilder();
        authBody.append(URLEncoder.encode("client_id", "UTF-8"));
        authBody.append("=");
        authBody.append(URLEncoder.encode("transparency-dashboard-frontend", "UTF-8"));
        authBody.append("&");
        authBody.append(URLEncoder.encode("grant_type", "UTF-8"));
        authBody.append("=");
        authBody.append(URLEncoder.encode("password", "UTF-8"));
        authBody.append("&");
        authBody.append(URLEncoder.encode("username", "UTF-8"));
        authBody.append("=");
        authBody.append(URLEncoder.encode("test-user", "UTF-8"));
        authBody.append("&");
        authBody.append(URLEncoder.encode("password", "UTF-8"));
        authBody.append("=");
        authBody.append(URLEncoder.encode("test-user", "UTF-8"));
        String authBodyStr = authBody.toString();

        try(OutputStream os = con.getOutputStream()){
                byte[] input = authBodyStr.getBytes("utf-8");
                os.write(input, 0, input.length);			
        }

        int code = con.getResponseCode();
        System.out.println(code);
        StringBuilder response = new StringBuilder();
        try(BufferedReader br = new BufferedReader(new InputStreamReader(con.getInputStream(), "utf-8"))){

                String responseLine = null;
                while ((responseLine = br.readLine()) != null) {
                        response.append(responseLine.trim());
                }
                System.out.println(response.toString());
        }

        JSONObject obj=new JSONObject(response.toString());
        String token=obj.getString("access_token");

        return token;
    }
 
}
