package com.tecnalia.across.ujse.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.tecnalia.across.ujse.model.InputData;
import io.swagger.v3.oas.annotations.media.Schema;
import java.util.ArrayList;
import java.util.List;
import org.springframework.validation.annotation.Validated;
import javax.validation.Valid;
import javax.validation.constraints.*;

/**
 * ServiceStore
 */
@Validated
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2022-03-27T21:30:41.655Z[GMT]")


public class ServiceStore   {
  @JsonProperty("channel")
  private String channel = null;

  @JsonProperty("contact")
  private String contact = null;

  @JsonProperty("location")
  private String location = null;

  @JsonProperty("inputDataRequired")
  @Valid
  private List<InputData> inputDataRequired = null;

  public ServiceStore channel(String channel) {
    this.channel = channel;
    return this;
  }

  /**
   * Get channel
   * @return channel
   **/
  @Schema(description = "")
  
    public String getChannel() {
    return channel;
  }

  public void setChannel(String channel) {
    this.channel = channel;
  }

  public ServiceStore contact(String contact) {
    this.contact = contact;
    return this;
  }

  /**
   * Get contact
   * @return contact
   **/
  @Schema(description = "")
  
  public String getContact() {
    return contact;
  }

  public void setContact(String contact) {
    this.contact = contact;
  }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }


  
  public ServiceStore inputDataRequired(List<InputData> inputDataRequired) {
    this.inputDataRequired = inputDataRequired;
    return this;
  }

  public ServiceStore addInputDataRequiredItem(InputData inputDataRequiredItem) {
    if (this.inputDataRequired == null) {
      this.inputDataRequired = new ArrayList<InputData>();
    }
    this.inputDataRequired.add(inputDataRequiredItem);
    return this;
  }

  /**
   * Get inputDataRequired
   * @return inputDataRequired
   **/
  @Schema(description = "")
      @Valid
    public List<InputData> getInputDataRequired() {
    return inputDataRequired;
  }

  public void setInputDataRequired(List<InputData> inputDataRequired) {
    this.inputDataRequired = inputDataRequired;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ServiceStore serviceStore = (ServiceStore) o;
    return Objects.equals(this.channel, serviceStore.channel) &&
        Objects.equals(this.contact, serviceStore.contact) &&
        Objects.equals(this.inputDataRequired, serviceStore.inputDataRequired);
  }

  @Override
  public int hashCode() {
    return Objects.hash(channel, contact, inputDataRequired);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ServiceStore {\n");
    
    sb.append("    channel: ").append(toIndentedString(channel)).append("\n");
    sb.append("    contact: ").append(toIndentedString(contact)).append("\n");
    sb.append("    inputDataRequired: ").append(toIndentedString(inputDataRequired)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
