package com.tecnalia.across.ujse.model;

import java.util.Objects;
import javax.validation.Valid;
import javax.xml.bind.annotation.XmlRootElement;

import org.springframework.validation.annotation.Validated;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonRawValue;

import io.swagger.v3.oas.annotations.media.Schema;
import java.util.UUID;

/**
 * UserWorkflowModel
 */
@Validated
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2022-03-14T13:00:17.932Z[GMT]")


@XmlRootElement(name="UserWorkflowModel")
public class UserWorkflowModel {
	

   private UUID workflowInstanceId;


  @JsonProperty("createdAt")
  private long createdAt;
  
  @JsonProperty("name")
  private String name;

  
  @JsonProperty("userId")
  private UUID userId;

  @JsonProperty("workflowId")
  private UUID workflowId;

  @JsonProperty("workflowType")
  private String workflowType;

  @JsonProperty("countryOrigin")
  private String countryOrigin ;

  @JsonProperty("countryDestination")
  private String countryDestination;

  @JsonProperty("workflowStatus")
  private String workflowStatus;

  @JsonProperty("trust")
  private boolean trust;
  
  @JsonRawValue
  private String workflowContent;

   @JsonRawValue
  private String servicesWithoutConsent;

  @JsonRawValue
  private String description;
  

  
  
  
   public UserWorkflowModel () {
   
  }


  /**
   * Get workflowInstanceId
   * @return workflowInstanceId
   **/
  @Schema(description = "")
  
    public UUID getWorkflowInstanceId() {
    return workflowInstanceId;
  }

  public void setWorkflowInstanceId(UUID workflowInstanceId) {
    this.workflowInstanceId = workflowInstanceId;
  }

 

  /**
   * Get createdAt
   * @return createdAt
   **/
  @Schema(description = "")
  
    @Valid
    public long getCreatedAt() {
    return createdAt;
  }

  public void setCreatedAt(long createdAt) {
    this.createdAt = createdAt;
  }

  public UserWorkflowModel userId(UUID userId) {
    this.userId = userId;
    return this;
  }

  /**
   * Get userId
   * @return userId
   **/
  @Schema(description = "")
  
    public UUID getUserId() {
    return userId;
  }

  public void setUserId(UUID userId) {
    this.userId = userId;
  }

  /**
   * Get name
   * @return name
   **/
  @Schema(description = "")
  
    public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }
  
  
  
   

  /**
   * Get workflowId
   * @return workflowId
   **/
  @Schema(description = "")
  
    public UUID getWorkflowId() {
    return workflowId;
  }

  public void setWorkflowId(UUID workflowId) {
    this.workflowId = workflowId;
  }


  /**
   * Get workflowType
   * @return workflowType
   **/
  @Schema(description = "")
  
    public String getWorkflowType() {
    return workflowType;
  }

  public void setWorkflowType(String workflowType) {
    this.workflowType = workflowType;
  }

  

  /**
   * Get countryOrigin
   * @return countryOrigin
   **/
  @Schema(description = "")
  
    public String getCountryOrigin() {
    return countryOrigin;
  }

  public void setCountryOrigin(String countryOrigin) {
    this.countryOrigin = countryOrigin;
  }

 
  /**
   * Get countryDestination
   * @return countryDestination
   **/
  @Schema(description = "")
  
    public String getCountryDestination() {
    return countryDestination;
  }

  public void setCountryDestination(String countryDestination) {
    this.countryDestination = countryDestination;
  }



  /**
   * Get workflowStatus
   * @return workflowStatus
   **/
  @Schema(description = "")
  
    public String getWorkflowStatus() {
    return workflowStatus;
  }

  public void setWorkflowStatus(String workflowStatus) {
    this.workflowStatus = workflowStatus;
  }


  /**
   * Get trust
   * @return trust
   **/
  @Schema(description = "")
  
    public boolean getTrust() {
    return trust;
  }

  public void setTrust(boolean trust) {
    this.trust = trust;
  }


  /**
   * Get workflowContent
   * @return workflowContent
   **/
  @Schema(description = "")
  
    public String getWorkflowContent() {
    return workflowContent;
  }

  public void setWorkflowContent(String workflowContent) {
    this.workflowContent = workflowContent;
  }

 
  

  /**
   * Get workflowContent
   * @return workflowContent
   **/
  @Schema(description = "")
  
    public String getServicesWithoutConsent() {
    return servicesWithoutConsent;
  }

  public void setServicesWithoutConsent(String servicesWithoutConsent) {
    this.servicesWithoutConsent = servicesWithoutConsent;
  }


  /**
   * Get description
   * @return description
   **/
  @Schema(description = "")
  
    public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  
  

  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserWorkflowModel userWorkflowStore = (UserWorkflowModel) o;
    return Objects.equals(this.workflowInstanceId, userWorkflowStore.workflowInstanceId) &&
        Objects.equals(this.createdAt, userWorkflowStore.createdAt) &&
        Objects.equals(this.userId, userWorkflowStore.userId) &&
        Objects.equals(this.name, userWorkflowStore.name) &&
        Objects.equals(this.workflowId, userWorkflowStore.workflowId) &&
        Objects.equals(this.workflowType, userWorkflowStore.workflowType) &&
        Objects.equals(this.countryOrigin, userWorkflowStore.countryOrigin) &&
        Objects.equals(this.countryDestination, userWorkflowStore.countryDestination) &&
        Objects.equals(this.workflowStatus, userWorkflowStore.workflowStatus) &&
        Objects.equals(this.trust, userWorkflowStore.trust) &&
        Objects.equals(this.workflowContent, userWorkflowStore.workflowContent)&&
        Objects.equals(this.servicesWithoutConsent, userWorkflowStore.servicesWithoutConsent)&&  
        Objects.equals(this.description, userWorkflowStore.description);
  }

  @Override
  public int hashCode() {
    return Objects.hash(workflowInstanceId, name,createdAt, userId, workflowId, workflowType, countryOrigin, countryDestination, workflowStatus, trust, workflowContent,servicesWithoutConsent,description);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserWorkflowStore {\n");
    
    sb.append("    workflowInstanceId: ").append(toIndentedString(workflowInstanceId)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    workflowId: ").append(toIndentedString(workflowId)).append("\n");
    sb.append("    workflowType: ").append(toIndentedString(workflowType)).append("\n");
    sb.append("    countryOrigin: ").append(toIndentedString(countryOrigin)).append("\n");
    sb.append("    countryDestination: ").append(toIndentedString(countryDestination)).append("\n");
    sb.append("    workflowStatus: ").append(toIndentedString(workflowStatus)).append("\n");
    sb.append("    trust: ").append(toIndentedString(trust)).append("\n");
    sb.append("    workflowContent: ").append(toIndentedString(workflowContent)).append("\n");
    sb.append("    servicesWithoutConsent: ").append(toIndentedString(servicesWithoutConsent)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
