package com.tecnalia.across.ujse.model.store;

import java.util.Objects;
import java.util.UUID;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.v3.oas.annotations.media.Schema;

import org.hibernate.annotations.GenericGenerator;
import org.springframework.validation.annotation.Validated;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;


/**
 * WorkflowStore
 */
@Validated
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2022-03-03T09:25:28.650Z[GMT]")

@Entity
@Table(name = "LogStore")
public class LogStore   {
    @Id
    @GeneratedValue(generator = "UUID")
    @GenericGenerator(
        name = "UUID",
        strategy = "org.hibernate.id.UUIDGenerator"
    )
    @Column(name = "logId")
    private String logId;
  
    
    @JsonProperty("userId")
    private String userId;
    @JsonProperty("workflowInstanceId")
    private String workflowInstanceId;
    @JsonProperty("phaseId")
    private String phaseId;
    @JsonProperty("actionId")
    private String actionId;
    @JsonProperty("serviceId")
    private String serviceId;

    
    @JsonProperty("description")
    private String description = "";

    @JsonProperty("createdOn")
    private String createdOn;
    
    @JsonProperty("updatedByUser")
    private boolean updatedByUser;

  
  /**
   * Get description
   * @return description
   **/
  @Schema(description = "")  
    public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  } 
  
    public String getCreatedOn() {
            return createdOn;
    }

    public void setCreatedOn(String createdOn) {
            this.createdOn = createdOn;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getWorkflowInstanceId() {
        return workflowInstanceId;
    }

    public void setWorkflowInstanceId(String workflowInstanceId) {
        this.workflowInstanceId = workflowInstanceId;
    }

    public String getPhaseId() {
        return phaseId;
    }

    public void setPhaseId(String phaseId) {
        this.phaseId = phaseId;
    }

    public String getActionId() {
        return actionId;
    }

    public void setActionId(String actionId) {
        this.actionId = actionId;
    }

    public String getServiceId() {
        return serviceId;
    }

    public void setServiceId(String serviceId) {
        this.serviceId = serviceId;
    }

    public boolean isUpdatedByUser() {
        return updatedByUser;
    }

    public void setUpdatedByUser(boolean updatedByUser) {
        this.updatedByUser = updatedByUser;
    }
        
  

  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    LogStore logStore = (LogStore) o;
    return Objects.equals(this.description, logStore.description) &&
        Objects.equals(this.createdOn, logStore.createdOn) &&
        Objects.equals(this.userId, logStore.userId) &&
        Objects.equals(this.workflowInstanceId, logStore.workflowInstanceId) &&
        Objects.equals(this.phaseId, logStore.phaseId) &&
        Objects.equals(this.actionId, logStore.actionId) &&
        Objects.equals(this.serviceId, logStore.serviceId) &&
        Objects.equals(this.updatedByUser, logStore.updatedByUser);
  }

  @Override
  public int hashCode() {
    return Objects.hash(description, description, userId, workflowInstanceId, 
            phaseId, actionId, serviceId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class LogStore {\n");
    
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    date: ").append(toIndentedString(createdOn)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    workflowInstanceId: ").append(toIndentedString(workflowInstanceId)).append("\n");
    sb.append("    phaseId: ").append(toIndentedString(phaseId)).append("\n");
    sb.append("    actionId: ").append(toIndentedString(actionId)).append("\n");
    sb.append("    serviceId: ").append(toIndentedString(serviceId)).append("\n");   
    sb.append("    updatedByUser: ").append(toIndentedString(updatedByUser)).append("\n");   
 
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
