package com.tecnalia.across.ujse.model.store;

import java.util.Objects;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.Table;
import javax.validation.Valid;

import org.hibernate.annotations.GenericGenerator;
import org.springframework.validation.annotation.Validated;


import io.swagger.v3.oas.annotations.media.Schema;

import java.util.UUID;
import javax.persistence.Column;
/**
 * UserWorkflowStore
 */
@Validated
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2022-03-14T13:00:17.932Z[GMT]")

@Entity
@Table(name = "UserWorkflowStore")

public class UserWorkflowStore   {
	
  @Id
    @GeneratedValue(generator = "UUID")
    @GenericGenerator(
        name = "UUID",
        strategy = "org.hibernate.id.UUIDGenerator"
    )
   
    private UUID workflowInstanceId;


  
  private long createdAt;

 
  private UUID userId;

  
  private UUID workflowId;

  private String workflowType;

 
  private String countryOrigin;

  
  private String countryDestination ;


  private String workflowStatus;


  private boolean trust = false;

  @Lob
  private String workflowContent;

  
  private String name = null;
  
   
  @Lob
  private String description;

  
  
   public UserWorkflowStore () {
      
   
  }

  
  
  
  
    /**
   * Get name
   * @return name
   **/

  
    public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }
   /**
   * Get description
   * @return description
   **/

  
    public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  /**
   * Get workflowInstanceId
   * @return workflowInstanceId
   **/
 
  
    public UUID getWorkflowInstanceId() {
    return workflowInstanceId;
  }

  public void setWorkflowInstanceId(UUID workflowInstanceId) {
    this.workflowInstanceId = workflowInstanceId;
  }



  /**
   * Get createdAt
   * @return createdAt
   **/
 
  
    @Valid
    public long getCreatedAt() {
    return createdAt;
  }

  public void setCreatedAt(long offsetDT1) {
    this.createdAt = offsetDT1;
  }



  /**
   * Get userId
   * @return userId
   **/
 
    public UUID getUserId() {
    return userId;
  }

  public void setUserId(UUID userId) {
    this.userId = userId;
  }


  /**
   * Get workflowId
   * @return workflowId
   **/
 
    public UUID getWorkflowId() {
    return workflowId;
  }

  public void setWorkflowId(UUID workflowId) {
    this.workflowId = workflowId;
  }



  /**
   * Get workflowType
   * @return workflowType
   **/

  
    public String getWorkflowType() {
    return workflowType;
  }

  public void setWorkflowType(String workflowType) {
    this.workflowType = workflowType;
  }



  /**
   * Get countryOrigin
   * @return countryOrigin
   **/
 
  
    public String getCountryOrigin() {
    return countryOrigin;
  }

  public void setCountryOrigin(String countryOrigin) {
    this.countryOrigin = countryOrigin;
  }



  /**
   * Get countryDestination
   * @return countryDestination
   **/
  
    public String getCountryDestination() {
    return countryDestination;
  }

  public void setCountryDestination(String countryDestination) {
    this.countryDestination = countryDestination;
  }

  /**
   * Get workflowStatus
   * @return workflowStatus
   **/
 
  
    public String getWorkflowStatus() {
    return workflowStatus;
  }

  public void setWorkflowStatus(String workflowStatus) {
    this.workflowStatus = workflowStatus;
  }


  /**
   * Get trust
   * @return trust
   **/
 
  
    public boolean getTrust() {
    return trust;
  }

  public void setTrust(boolean trust) {
    this.trust = trust;
  }



  /**
   * Get workflowContent
   * @return workflowContent
   **/
  @Schema(description = "")
  
    public String getWorkflowContent() {
    return workflowContent;
  }

  public void setWorkflowContent(String workflowContent) {
    this.workflowContent = workflowContent;
  }



  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserWorkflowStore userWorkflowStore = (UserWorkflowStore) o;
    return Objects.equals(this.workflowInstanceId, userWorkflowStore.workflowInstanceId) &&
        Objects.equals(this.createdAt, userWorkflowStore.createdAt) &&
        Objects.equals(this.userId, userWorkflowStore.userId) &&
        Objects.equals(this.workflowId, userWorkflowStore.workflowId) &&
        Objects.equals(this.workflowType, userWorkflowStore.workflowType) &&
        Objects.equals(this.countryOrigin, userWorkflowStore.countryOrigin) &&
        Objects.equals(this.countryDestination, userWorkflowStore.countryDestination) &&
        Objects.equals(this.workflowStatus, userWorkflowStore.workflowStatus) &&
        Objects.equals(this.workflowContent, userWorkflowStore.workflowContent) &&
        Objects.equals(this.trust, userWorkflowStore.trust);
  }

  @Override
  public int hashCode() {
    return Objects.hash(workflowInstanceId, createdAt, userId, workflowId, workflowType, countryOrigin, countryDestination, workflowStatus, workflowContent);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserWorkflowStore {\n");
    
    sb.append("    workflowInstanceId: ").append(toIndentedString(workflowInstanceId)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    workflowId: ").append(toIndentedString(workflowId)).append("\n");
    sb.append("    workflowType: ").append(toIndentedString(workflowType)).append("\n");
    sb.append("    countryOrigin: ").append(toIndentedString(countryOrigin)).append("\n");
    sb.append("    countryDestination: ").append(toIndentedString(countryDestination)).append("\n");
    sb.append("    workflowStatus: ").append(toIndentedString(workflowStatus)).append("\n");
    sb.append("    trust: ").append(toIndentedString(trust)).append("\n");
    sb.append("    workflowContent: ").append(toIndentedString(workflowContent)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
