package com.tecnalia.across.ujse.model.store;

import java.util.Objects;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import java.util.UUID;
import javax.persistence.Column;

import org.hibernate.annotations.GenericGenerator;
import org.springframework.validation.annotation.Validated;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.Table;
import javax.validation.Valid;
/**
 * WorkflowStore
 */
@Validated
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2022-03-03T09:25:28.650Z[GMT]")

@Entity
@Table(name = "WorkflowStore")
public class WorkflowStore   {
  
    @Id
    @GeneratedValue(generator = "UUID")
    @GenericGenerator(
        name = "UUID",
        strategy = "org.hibernate.id.UUIDGenerator"
    )
 
   
  private UUID workflowId;

  private String jsonfilename;


  private String workflowType ;


  private String countryOrigin;


  private String countryDestination;
  
  private boolean trust = false;
  
  @Lob 
  private byte[] jsonfile;
  
  @Lob
  private byte[] jsonfileInternal;
  

  public WorkflowStore () {
   
  }

  /**
   * Get workflowId
   * @return workflowId
   **/
 
  
    public UUID getWorkflowId() {
    return workflowId;
  }

  public void setWorkflowId(UUID workflowId) {
    this.workflowId = workflowId;
  }


  /**
   * Get workflowName
   * @return workflowName
   **/
 
  
    public String getJSONFileName() {
    return jsonfilename;
  }

  public void setJSONFileName(String jsonfilename) {
    this.jsonfilename = jsonfilename;
  }

 

  /**
   * Get workflowType
   * @return workflowType
   **/
 
  
    public String getWorkflowType() {
    return workflowType;
  }

  public void setWorkflowType(String workflowType) {
    this.workflowType = workflowType;
  }



  /**
   * Get countryOrigin
   * @return countryOrigin
   **/

  
    public String getCountryOrigin() {
    return countryOrigin;
  }

  public void setCountryOrigin(String countryOrigin) {
    this.countryOrigin = countryOrigin;
  }



  /**
   * Get countryDestination
   * @return countryDestination
   **/

    public String getCountryDestination() {
    return countryDestination;
  }

  public void setCountryDestination(String countryDestination) {
    this.countryDestination = countryDestination;
  }

 
  /**
   * Get trust
   * @return trust
   **/

    public boolean getTrust() {
    return trust;
  }

  public void setTrust(boolean trust) {
    this.trust = trust;
  }

  
    @Valid
    public byte[] getJSONfile() {
    return jsonfile;
  }

  public void setJSONfile(byte[] jsonfile) {
    this.jsonfile = jsonfile;
  }
  
  
 
  
  
     @Valid
    public byte[] getJSONfileInternal() {
    return jsonfileInternal;
  }
    public void setJSONfileInternal(byte[] jsonfileInternal) {
    this.jsonfileInternal = jsonfileInternal;
  }
  
  
  

  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WorkflowStore workflowStore = (WorkflowStore) o;
    return Objects.equals(this.workflowId, workflowStore.workflowId) &&
        Objects.equals(this.jsonfilename, workflowStore.jsonfilename) &&
        Objects.equals(this.workflowType, workflowStore.workflowType) &&
        Objects.equals(this.countryOrigin, workflowStore.countryOrigin) &&
        Objects.equals(this.countryDestination, workflowStore.countryDestination) &&
        Objects.equals(this.trust, workflowStore.trust) &&
        Objects.equals(this.jsonfile, workflowStore.jsonfile)&&
        Objects.equals(this.jsonfileInternal, workflowStore.jsonfileInternal);
  }

  @Override
  public int hashCode() {
    return Objects.hash(workflowId, jsonfilename, workflowType, countryOrigin, countryDestination, trust, jsonfile,jsonfileInternal);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WorkflowStore {\n");
    
    sb.append("    workflowId: ").append(toIndentedString(workflowId)).append("\n");
    sb.append("    workflowName: ").append(toIndentedString(jsonfilename)).append("\n");
    sb.append("    workflowType: ").append(toIndentedString(workflowType)).append("\n");
    sb.append("    countryOrigin: ").append(toIndentedString(countryOrigin)).append("\n");
    sb.append("    countryDestination: ").append(toIndentedString(countryDestination)).append("\n");
    sb.append("    trust: ").append(toIndentedString(trust)).append("\n");
    sb.append("    jsonfile: ").append(toIndentedString(jsonfile)).append("\n");
 //   sb.append("    jsonfileInternal: ").append(toIndentedString(jsonfileInternal)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

