package com.tecnalia.across.ujse.repository;


import javax.transaction.Transactional;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import com.tecnalia.across.ujse.model.store.LogStore;
import java.util.List;
import java.util.UUID;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;




@Transactional(rollbackOn=Exception.class)
@Repository
//public interface BPMNFileRepository extends JpaRepository<BPMNStore, Long> {
public interface LogRepository extends JpaRepository<LogStore, String> {
	
    /**
     * Returns a {@link Page} of entities meeting the paging restriction provided in the {@code Pageable} object.
     *
     * @param pageable
     * @return a page of entities
     */
    @Query(value = "SELECT l FROM LogStore l WHERE l.userId=:userId and "
           + "((:workflowInstanceId is null or l.workflowInstanceId = :workflowInstanceId) and "
           + "(:phaseId is null or l.phaseId = :phaseId) and"
           + "(:actionId is null or l.actionId = :actionId) and "
           + "(:serviceId is null or l.serviceId = :serviceId))"
           + " ORDER BY l.createdOn DESC",
           countQuery = "SELECT count(l) FROM LogStore l WHERE l.userId=:userId and "
           + "((:workflowInstanceId is null or l.workflowInstanceId = :workflowInstanceId) and "
           + "(:phaseId is null or l.phaseId = :phaseId) and"
           + "(:actionId is null or l.actionId = :actionId) and "
           + "(:serviceId is null or l.serviceId = :serviceId))"
           )
    Page < LogStore > findAllByUserIdAndWorkflowInstanceIdAndPhaseIdAndActionIdAndServiceIdPage(String userId, String workflowInstanceId, String phaseId, String actionId, String serviceId, 
            Pageable pageable);	
	

    @Query("SELECT l FROM LogStore l WHERE l.userId=:userId and "
           + "((:workflowInstanceId is null or l.workflowInstanceId = :workflowInstanceId) and "
           + "(:phaseId is null or l.phaseId = :phaseId) and"
           + "(:actionId is null or l.actionId = :actionId) and "
           + "(:serviceId is null or l.serviceId = :serviceId))"
           + " ORDER BY l.createdOn DESC")
    List < LogStore > findAllByUserIdAndWorkflowInstanceIdAndPhaseIdAndActionIdAndServiceId(String userId, String workflowInstanceId, String phaseId, String actionId, String serviceId);	


    /**
     * Returns a {@link Page} of entities meeting the paging restriction provided in the {@code Pageable} object.
     *
     * @param pageable
     * @return a page of entities
     */
    @Query(value = "SELECT l FROM LogStore l WHERE l.userId=:userId and "
           + "((l.workflowInstanceId = :workflowInstanceId) and "
           + "(l.phaseId = :phaseId) and"
           + "(l.actionId = :actionId) and "
           + "(l.serviceId is null))"
           + " ORDER BY l.createdOn DESC",
           countQuery = "SELECT count(l) FROM LogStore l WHERE l.userId=:userId and "
           + "((l.workflowInstanceId = :workflowInstanceId) and "
           + "(l.phaseId = :phaseId) and"
           + "(l.actionId = :actionId) and "
           + "(l.serviceId is null))"
           )
    Page < LogStore > findByUserIdAndWorkflowInstanceIdAndPhaseIdAndActionIdPage(String userId, String workflowInstanceId, String phaseId, String actionId, 
            Pageable pageable);	
	

    @Query("SELECT l FROM LogStore l WHERE l.userId=:userId and "
           + "((l.workflowInstanceId = :workflowInstanceId) and "
           + "(l.phaseId = :phaseId) and"
           + "(l.actionId = :actionId) and "
           + "(l.serviceId is null))"
           + " ORDER BY l.createdOn DESC")
    List < LogStore > findByUserIdAndWorkflowInstanceIdAndPhaseIdAndActionId(String userId, String workflowInstanceId, String phaseId, String actionId);	

    
    /**
     * Returns a {@link Page} of entities meeting the paging restriction provided in the {@code Pageable} object.
     *
     * @param pageable
     * @return a page of entities
     */
    @Query(value = "SELECT l FROM LogStore l WHERE l.userId=:userId and "
           + "((l.workflowInstanceId = :workflowInstanceId) and "
           + "(l.phaseId = :phaseId) and"
           + "(l.actionId = :actionId) and "
           + "(l.serviceId = :serviceId))"
           + " ORDER BY l.createdOn DESC",
           countQuery = "SELECT count(l) FROM LogStore l WHERE l.userId=:userId and "
           + "((l.workflowInstanceId = :workflowInstanceId) and "
           + "(l.phaseId = :phaseId) and"
           + "(l.actionId = :actionId) and "
           + "(l.serviceId = :serviceId))"
           )
    Page < LogStore > findByUserIdAndWorkflowInstanceIdAndPhaseIdAndActionIdAndServiceIdPage(String userId, String workflowInstanceId, String phaseId, String actionId, String serviceId, 
            Pageable pageable);	
	

    @Query("SELECT l FROM LogStore l WHERE l.userId=:userId and "
           + "((l.workflowInstanceId = :workflowInstanceId) and "
           + "(l.phaseId = :phaseId) and"
           + "(l.actionId = :actionId) and "
           + "(l.serviceId = :serviceId))"
           + " ORDER BY l.createdOn DESC")
    List < LogStore > findByUserIdAndWorkflowInstanceIdAndPhaseIdAndActionIdAndServiceId(String userId, String workflowInstanceId, String phaseId, String actionId, String serviceId);	



    @Query("SELECT count(l) FROM LogStore l "
           + "WHERE l.description like 'Workflow instance % created %'")
    long getCountOfStartedJourneys();	


    @Query("SELECT count(distinct l.userId) FROM LogStore l "
           + "WHERE l.description like 'Workflow instance % created %'")
    long getCountOfUsersStartedJourney();
}

