package com.tecnalia.across.ujse.repository;

import java.util.Optional;
import java.util.UUID;

import javax.transaction.Transactional;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import com.tecnalia.across.ujse.model.store.UserWorkflowStore;

import org.springframework.data.jpa.repository.Query;





@Transactional(rollbackOn=Exception.class)
@Repository
public interface UserWorkflowRepository extends JpaRepository<UserWorkflowStore, UUID> {
	
	
    Optional<UserWorkflowStore> findByWorkflowInstanceId(UUID workflowInstanceId);
    Iterable<UserWorkflowStore> findAllByWorkflowInstanceId(UUID workflowInstanceId);
    
    
    @Query("SELECT c FROM UserWorkflowStore c WHERE c.userId=:userId and "
           + "((:countryOrigin is null or c.countryOrigin = :countryOrigin) and "
           + "(:countryDestination is null or c.countryDestination = :countryDestination) and"
           + "(:workflowType is null or c.workflowType = :workflowType))")
    Iterable<UserWorkflowStore> findAllByUserIdAndCountryOriginAndCountryDestinationAndWorkflowType(UUID userId, String countryOrigin,String countryDestination,  String workflowType);
    Optional<UserWorkflowStore> deleteByWorkflowInstanceId(UUID workflowInstanceId);
    Iterable<UserWorkflowStore> findAByUserIdAndCountryOriginAndCountryDestinationAndWorkflowTypeAndWorkflowStatus(UUID userId, String countryOrigin,String countryDestination, String workflowType, String workflowStatus);
	
	
	
}

