/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.tecnalia.across.ujse.utils;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;

import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

/**
 *
 * @author 107126
 * 
 * This class builds up HTTP or HTTPS endpoint connections and sends GET requests.
 */
@Service
public class HttpUtils {
    private static final Logger LOGGER = LoggerFactory.getLogger(HttpUtils.class);

    public static void disableCertificateCheck() {
        javax.net.ssl.TrustManager x509 = new javax.net.ssl.X509TrustManager() {
          public void checkClientTrusted(java.security.cert.X509Certificate[] arg0, String arg1) throws java.security.cert.CertificateException {
          }

          public void checkServerTrusted(java.security.cert.X509Certificate[] arg0, String arg1) throws java.security.cert.CertificateException {
          }

          public java.security.cert.X509Certificate[] getAcceptedIssuers() {
            return null;
          }
        };
        SSLContext ctx = null;
        try {
          ctx = SSLContext.getInstance("SSL");
          ctx.init(null, new javax.net.ssl.TrustManager[] {x509}, null);
        } catch(java.security.GeneralSecurityException ex) {
        }


        // Create all-trusting host name verifier
        HostnameVerifier allHostsValid = new HostnameVerifier() {
          public boolean verify(String hostname, SSLSession session) {
            return true;
          }
        };
        // Install the all-trusting host verifier
        HttpsURLConnection.setDefaultHostnameVerifier(allHostsValid);
        HttpsURLConnection.setDefaultSSLSocketFactory(ctx.getSocketFactory());
    }
    
    
    public String sendGETRequest(String address,String token) throws IOException{
        System.out.println("sendGETRequest, URL:"+ address);
    	//TODO: Remove this
        disableCertificateCheck();
    	
    	URL url = new URL (address);
		
        HttpURLConnection con = (HttpURLConnection)url.openConnection();
        con.setRequestMethod("GET");

        con.setRequestProperty("Content-Type", "application/json; utf-8");
        con.setRequestProperty("Accept", "application/json");
        if (token!=null)
            con.setRequestProperty("Authorization", "Bearer "+ token);
        
        con.setDoOutput(true);
    


        int code = con.getResponseCode();
        System.out.println(code);
        StringBuilder response = new StringBuilder();
        try(BufferedReader br = new BufferedReader(new InputStreamReader(con.getInputStream(), "utf-8"))){

                String responseLine = null;
                while ((responseLine = br.readLine()) != null) {
                        response.append(responseLine.trim());
                }
                //System.out.println(response.toString());
        }



        return response.toString();
    }
    
    
    public String sendPOSTRequest(String address,String token,String body) throws IOException{
        System.out.println("sendPOSTRequest, URL:"+ address);
        //System.out.println("sendPOSTRequest, body:"+ body);
    	//TODO: Remove this
    	disableCertificateCheck();
    	
    	URL url = new URL (address);
		
        HttpURLConnection con = (HttpURLConnection)url.openConnection();
        con.setRequestMethod("POST");

        con.setRequestProperty("Content-Type", "application/json; charset=UTF-8");
        con.setRequestProperty("Accept", "application/json");
        if (token!=null)
            con.setRequestProperty("Authorization", "Bearer "+ token);
        con.setDoOutput(true);
        if (body!=null){                       
            try(OutputStream os = con.getOutputStream()) {
                byte[] input = body.getBytes("utf-8");
                os.write(input, 0, input.length);
                os.flush();
		os.close();
            }
        }

        int code = con.getResponseCode();
        System.out.println(code);
        StringBuilder response = new StringBuilder();
        try(BufferedReader br = new BufferedReader(new InputStreamReader(con.getInputStream(), "utf-8"))){

                String responseLine = null;
                while ((responseLine = br.readLine()) != null) {
                        response.append(responseLine.trim());
                }
                //System.out.println(response.toString());
        }



        return response.toString();
	}
     
   
    public String sendPUTRequest(String address,String token,String body) throws IOException{
        System.out.println("sendPUTRequest, URL:"+ address);
    	//TODO: Remove this
    	disableCertificateCheck();
    	
    	URL url = new URL (address);
		
        HttpURLConnection con = (HttpURLConnection)url.openConnection();
        con.setRequestMethod("PUT");

        con.setRequestProperty("Content-Type", "application/json; charset=UTF-8");
        con.setRequestProperty("Accept", "application/json");
        if (token!=null)
            con.setRequestProperty("Authorization", "Bearer "+ token);
        con.setDoOutput(true);
        if (body!=null){                       
            try(OutputStream os = con.getOutputStream()) {
                byte[] input = body.getBytes("utf-8");
                os.write(input, 0, input.length);
                os.flush();
		os.close();
            }
        }

        int code = con.getResponseCode();
        System.out.println(code);
        StringBuilder response = new StringBuilder();
        try(BufferedReader br = new BufferedReader(new InputStreamReader(con.getInputStream(), "utf-8"))){

                String responseLine = null;
                while ((responseLine = br.readLine()) != null) {
                        response.append(responseLine.trim());
                }
                //System.out.println(response.toString());
        }



        return response.toString();
	}
}
