/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.tecnalia.across.ujse.utils;

import com.tecnalia.across.ujse.model.UserInfo;
import java.security.Principal;
import java.util.Map;
import org.keycloak.KeycloakPrincipal;
import org.keycloak.adapters.springsecurity.token.KeycloakAuthenticationToken;
import org.keycloak.representations.AccessToken;
import org.keycloak.representations.AddressClaimSet;
import org.springframework.security.core.context.SecurityContextHolder;

/**
 *
 * @author tecnalia
 */
public final class IdentityUtils {
    public static UserInfo getUserInfoFromAccessToken() {
        UserInfo userInfo = new UserInfo();
        KeycloakAuthenticationToken authentication = (KeycloakAuthenticationToken) SecurityContextHolder.getContext().getAuthentication();
        
        Principal principal = (Principal) authentication.getPrincipal();        
        userInfo.setUserId(principal.getName());
        String dob="";
        
        if (principal instanceof KeycloakPrincipal) {
            KeycloakPrincipal kPrincipal = (KeycloakPrincipal) principal;
            AccessToken accessToken = kPrincipal.getKeycloakSecurityContext().getToken();
            userInfo.setAccessToken(kPrincipal.getKeycloakSecurityContext().getTokenString());
            try {
                userInfo.setUsername(accessToken.getPreferredUsername());
                userInfo.setEmail(accessToken.getEmail());
                userInfo.setFirstname(accessToken.getGivenName());
                userInfo.setLastname(accessToken.getFamilyName());
                AddressClaimSet addressSet = accessToken.getAddress();
                userInfo.setCountry(addressSet.getCountry());
                userInfo.setZipCode(addressSet.getPostalCode());
                userInfo.setStreet(addressSet.getStreetAddress());
                userInfo.setState(addressSet.getRegion());
                userInfo.setCity(addressSet.getLocality());
                userInfo.setAddress(addressSet.getFormattedAddress());
            } catch (Exception e) {
                e.printStackTrace();
                System.out.println("Data not available in access-token:"+e.getMessage());
            }
            Map<String, Object> customClaims = accessToken.getOtherClaims();

            if (customClaims.containsKey("DOB")) {
                dob = String.valueOf(customClaims.get("DOB"));
            }
        }
        
        return userInfo;
        
    }
    
    
}
