/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.tecnalia.across.ujse.utils;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.tecnalia.across.ujse.external.ServiceCatalogueENG;
import com.tecnalia.across.ujse.model.MultilingValue;
import com.tecnalia.across.ujse.model.ServiceStore;
import com.tecnalia.across.ujse.model.workflow.engine.Action;
import com.tecnalia.across.ujse.model.workflow.engine.Action;
import com.tecnalia.across.ujse.model.workflow.engine.InternalJson;
import com.tecnalia.across.ujse.model.workflow.engine.Phase;
import com.tecnalia.across.ujse.model.workflow.engine.Touchpoint;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import org.json.JSONArray;
import org.json.JSONObject;

/**
 *
 * @author tecnalia
 * 
 * This class has methods to manage the workflow content.
*/
public final class WorkflowUtils {
    public final static String ACT_INITIAL_STATUS = "pending";
    public final static String SERV_INITIAL_STATUS = "open";
    

    public final HashMap<String, Object>   readJSONFile(byte[] JSONFile) throws IOException {
         
        
       
        String content = new String (JSONFile);
        //System.out.println("Internal Content:"+content);

        ObjectMapper mapper = new ObjectMapper();
        mapper.configure(JsonParser.Feature.ALLOW_UNQUOTED_FIELD_NAMES, true);

        InternalJson intJson = mapper.readValue(content, InternalJson.class);
        
        
       
        ArrayList<String> aServicesId=new ArrayList<>();
        
        HashMap<UUID,HashMap<UUID,ArrayList<String>>> phaseActionIdServicesEquivalences=new HashMap<>();
        HashMap<UUID,ArrayList<UUID>> phaseActions=new HashMap<>();
        
        
        
        JSONObject contentJson = new JSONObject(content);
        JSONArray descriptionJsonArr = contentJson.getJSONArray("description");
        String description = descriptionJsonArr.toString();
        
        ArrayList<Phase> aPhases= intJson.getPhases();
        for (int i=0;i<aPhases.size();i++){
            HashMap<UUID,ArrayList<String>> actionIdServicesEquivalences = new HashMap<>();
            Phase phase=aPhases.get(i);
            ArrayList<Action> aAction=phase.getActions();
            ArrayList<String> actionServices=null;
            ArrayList<UUID> aActions=new ArrayList<UUID>();
            for (int j=0;j<aAction.size();j++){
                actionServices=new ArrayList<>();
                Action action=aAction.get(j);
                aActions.add(UUID.fromString(action.getAction_id()));
                
                ArrayList<Touchpoint> aTouch=action.getTouchpoints();
                for (int k=0;k<aTouch.size();k++){
                    Touchpoint touch=aTouch.get(k);
                    String serviceId=touch.getService_id();
                    if (!(aServicesId.contains(serviceId))){
                        aServicesId.add(serviceId);
                    }    
                    if (!(actionServices.contains(serviceId)))
                        actionServices.add(serviceId);
                        
                    
                }
        
                actionIdServicesEquivalences.put(UUID.fromString(action.getAction_id()), actionServices);
            }
            phaseActions.put(UUID.fromString(phase.getPhase_id()), aActions);
            
            phaseActionIdServicesEquivalences.put(UUID.fromString(phase.getPhase_id()),actionIdServicesEquivalences);
            
        }
        
        
        HashMap<String,Object> result=new HashMap<String, Object>();
       
        String json = mapper.writeValueAsString(intJson.getPhases());
        
        result.put("description",description);
        result.put("workflowContent",json);
        result.put("servicesId", aServicesId);
        result.put("actionServices",phaseActionIdServicesEquivalences);
        result.put("phaseActions", phaseActions);
        
        
        
        /*for (Map.Entry<UUID, HashMap<UUID,ArrayList<String>>> set :phaseActionIdServicesEquivalences.entrySet()) {
 
            // Printing all elements of a Map
            System.out.println(set.getKey() + " = "+ set.getValue());
        }*/
        
       
        return result;
     }


    public String removeDrawIdKeyFromJSON (String content, String label){


        JSONObject jsonObj=new JSONObject(content);
         /* jsonObj.getJSONArray("phases").remove("drawio_id");
          jsonObj.getJSONArray("phases").getJSONArray("actions").remove("drawio_id");*/

        JSONArray jsonPhases=jsonObj.getJSONArray("phases");

        for (int i=0;i<jsonPhases.length();i++){
            JSONObject jObj=jsonPhases.getJSONObject(i);
            jObj.remove(label);
            JSONArray jarray=jObj.getJSONArray("actions");
            for (int j=0;j<jarray.length();j++){
                JSONObject jObjAction=jarray.getJSONObject(j);
                jObjAction.remove(label);
                JSONArray jarrayTouch=jObjAction.getJSONArray("touchpoints");
                for (int k=0;k<jarrayTouch.length();k++){
                     JSONObject jObjTouch=jarrayTouch.getJSONObject(k);
                     jObjTouch.remove(label);
                     jObjTouch.remove("name");
                     jObjTouch.remove("description");
                }
            }
        }
        content=jsonObj.toString();
        return content;    
    }
    
  
    public InternalJson convertInitialToInternalJson (String mtJsonString) throws JsonProcessingException{

        try{

            ObjectMapper mapper = new ObjectMapper();
            mapper.configure(JsonParser.Feature.ALLOW_UNQUOTED_FIELD_NAMES, true);


            System.out.println ("MTString:"+mtJsonString);

            InternalJson intJson = mapper.readValue(mtJsonString, InternalJson.class);
            //set wf status pending
            try{
                List<MultilingValue> desc=intJson.getDescription();
                if (desc==null) {
                    List<MultilingValue> multiVals = new ArrayList<MultilingValue>();
                    MultilingValue multiVal = new MultilingValue();
                    multiVal.setLocale("en");
                    multiVal.setValue("");
                    multiVals.add(multiVal);
                    intJson.setDescription(multiVals);
                }
            }
            catch(Exception e){
                List<MultilingValue> multiVals = new ArrayList<MultilingValue>();
                MultilingValue multiVal = new MultilingValue();
                multiVal.setLocale("en");
                multiVal.setValue("");
                multiVals.add(multiVal);
                intJson.setDescription(multiVals);
            }
            intJson.setStatus("pending");
            ArrayList<Phase> aPhases= intJson.getPhases();
            for (int i=0;i<aPhases.size();i++){
                Phase phase=aPhases.get(i);
                     phase.setPhase_id(UUID.randomUUID().toString());

                ArrayList<Action> aAction=phase.getActions();
                for (int j=0;j<aAction.size();j++){
                    Action action=aAction.get(j);
                    action.setStatus(ACT_INITIAL_STATUS);
                    action.setAction_id(UUID.randomUUID().toString());
                    ArrayList<Touchpoint> aTouch=action.getTouchpoints();
                    for (int k=0;k<aTouch.size();k++){
                        Touchpoint touch=aTouch.get(k);
                        touch.setStatus(SERV_INITIAL_STATUS);
                    }
                }
            }

            System.out.println (intJson.toString());
            return intJson;
        }
        catch(Exception e){
            System.out.println (e.getMessage());
            return null;
        }

    }  


    public boolean checkActionServiceStatusPossibleValues(String status) {
        boolean correct_status = false;
        status = status.toLowerCase();
        // open, pending, finished, returned, denied, skipped
        if (status.equals("pending")|| status.equals("finished") || 
                status.equals("open") || status.equals("returned") ||
                status.equals("denied") || status.equals("skipped") ||
                status.equals("submitted") || status.equals("rejected"))
                correct_status = true;
        return correct_status;
    }

    public String setWorkflowContentActionStatus(String actionId, String status, String workflowContent) throws JsonProcessingException {
        ObjectMapper mapper = new ObjectMapper();
        mapper.configure(JsonParser.Feature.ALLOW_UNQUOTED_FIELD_NAMES, true);
        List<Phase> aPhases = mapper.readValue(workflowContent, new TypeReference<List<Phase>>(){});
        boolean action_found = false;
        for (int i=0;i<aPhases.size();i++){
            Phase phase=aPhases.get(i);
            ArrayList<Action> aAction=phase.getActions();
            for (int j=0;j<aAction.size();j++){
                Action action=aAction.get(j);
                String action_Id=action.getAction_id();
                if (action_Id.equals(actionId)){
                    action.setStatus(status);
                    action_found = true;
                    break;
                }
            }
            if (action_found)
                break;
        }
        String json_str = mapper.writeValueAsString(aPhases);
        return json_str;
    }
                
    public String setWorkflowContentServiceStatus(String phaseId, String actionId, String serviceId, 
            String status, String serviceOutput, String workflowContent) throws JsonProcessingException {
        ObjectMapper mapper = new ObjectMapper();
        mapper.configure(JsonParser.Feature.ALLOW_UNQUOTED_FIELD_NAMES, true);
        List<Phase> aPhases = mapper.readValue(workflowContent, new TypeReference<List<Phase>>(){});
        boolean service_found = false;
        for (int i=0;i<aPhases.size();i++){
            Phase phase=aPhases.get(i);
            if (phase.getPhase_id().equals(phaseId)){
                ArrayList<Action> aAction=phase.getActions();
                for (int j=0;j<aAction.size();j++){
                    Action action=aAction.get(j);
                    String action_Id=action.getAction_id();
                    if (action_Id.equals(actionId)){
                        ArrayList<Touchpoint> aTouch=action.getTouchpoints();
                        for (int k=0;k<aTouch.size();k++){
                            Touchpoint touch=aTouch.get(k);
                            String service_Id=touch.getService_id();
                            if (service_Id.equals(serviceId)){
                                touch.setStatus(status);
                                touch.setServiceOutput(serviceOutput);
                                service_found = true;
                                break;
                            }
                        }
                        if (service_found)
                            break;
                    }
                }
                if (service_found)
                    break;
            }
        }
        String json_str = mapper.writeValueAsString(aPhases);
        return json_str;
    }
                
    
    public String setWorkflowContentServicesInfo(String getServiceInfoUrl, String workflowContent) throws JsonProcessingException {
        ServiceCatalogueENG serviceCatalogueENG = new ServiceCatalogueENG();
        ObjectMapper mapper = new ObjectMapper();
        mapper.configure(JsonParser.Feature.ALLOW_UNQUOTED_FIELD_NAMES, true);
        List<Phase> aPhases = mapper.readValue(workflowContent, new TypeReference<List<Phase>>(){});
        for (int i=0;i<aPhases.size();i++){
            Phase phase=aPhases.get(i);
            ArrayList<Action> aAction=phase.getActions();
            for (int j=0;j<aAction.size();j++){
                Action action=aAction.get(j);
                String action_Id=action.getAction_id();
                ArrayList<Touchpoint> aTouch=action.getTouchpoints();
                for (int k=0;k<aTouch.size();k++){
                    Touchpoint touch=aTouch.get(k);
                    String service_Id=touch.getService_id();
                    String channel = "Not found";
                    String location = "";
                    HashMap<String, ArrayList<MultilingValue>> nameDesHM = new HashMap<>();
                    try {
                        ServiceStore servInfo = serviceCatalogueENG.getServiceInfo(service_Id, getServiceInfoUrl);
                        channel = servInfo.getChannel();
                        location = servInfo.getLocation();
                        nameDesHM = serviceCatalogueENG.getServiceDescriptions(service_Id, getServiceInfoUrl);                        
                    } catch (IOException e) {
                    }                    
                    touch.setChannel(channel);
                    touch.setLocation(location);
                    touch.setName(nameDesHM.get("name"));
                    touch.setDescription(nameDesHM.get("description"));
                }
            }
        }
        String json_str = mapper.writeValueAsString(aPhases);
        return json_str;
    }
}
